﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AceGrep
{
    public class Line : Perusable
    {
        public override bool reading()
        {
            bool b = false;
            string line = EMPTY;

            try
            {
                for (; ; )
                {
                    line = Console.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        b = true;
                        Console.WriteLine(line);
                    }

                }

            }
            catch (IOException e69)
            {
                Error.handler(e69.ToString());
                plus("IOException e69");
            }

            return b;
        }

        public override bool reading(string fileName)
        {
            bool b = false;

            try
            {
                StreamReader file = new StreamReader(fileName, Encoding.Default);
                string line = EMPTY;

                for (; ; )
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        b = true;
                        Console.WriteLine(line);
                    }

                }

                file.Close();
            }
            catch (IOException e70)
            {
                Error.handler(e70.ToString());
                plus("IOException e70");
            }

            return b;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            bool b = false;

            try
            {
                StreamReader file = new StreamReader(fileName, encoding);
                string line = EMPTY;
                for (; ; )
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        b = true;
                        Console.WriteLine(line);
                    }

                }

                file.Close();
            }
            catch (IOException e71)
            {
                Error.handler(e71.ToString());
                plus("IOException e71");
            }

            return b;
        }

        public Line(string re, bool insensitive)
        {
            case_sensitive = !insensitive;

            if (compiling(re))
            {
                error = EMPTY;
            }
            else
            {
                error = "compiling(re): /" + re + "/";
            }

        }

    }
}
