﻿using System;
using System.Collections.Generic;
using System.Diagnostics; // Process
using System.IO;
using System.Linq;
using System.Text;

/*
AceGrep Version 1.01
Extracting lines from the file if they include sequences that match the regular expression.
Copyright 2018 Sogaya

Visual C# 2008 Express

*/

namespace AceGrep
{
    class Program
    {
        static void Main(string[] args)
        {
            const string ACE_GREP_PDF = "C:\\AceGrep\\AceGrep.pdf";
            const string PDF = "-p";

            int k = 0;
            string[] parameters = { "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "" }; // parameters.Length = 50

            foreach (string s in args)
            {
                if (k >= parameters.Length)
                {
                    break;
                }

                switch (s)
                {
                    case PDF:
                        Process p = new Process();
                        p.StartInfo.FileName = ACE_GREP_PDF;
                        p.Start();
                        System.Environment.Exit(0);
                        break;
                    default:
                        parameters[k++] = s;
                        break;
                } // switch

            } // foreach

            string[] items = new string[k];

            try
            {
                Array.Copy(parameters, 0, items, 0, k);
            }
            catch (ArgumentException e48)
            {
                Error.handler(e48.ToString());
            }

            Grep grep = new Grep();
            parameters = grep.singleCharacterParameters(items);
            grep.commandLine(parameters);
            int r = grep.run();
            System.Environment.Exit(r);
        }

    }
}
