﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AceGrep
{
    class Singleton
    {
        private int i = 0;
        private static Singleton instance = new Singleton();
        private Singleton()
        {
        }

        public static Singleton get_instance()
        {
            return instance;
        }

        public int increment()
        {
            return ++i;
        }

        public void setTo(int data)
        {
            i = data;
        }

    }
}
