﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SideAce
{
    public partial class Version : Form
    {
        const int BUTTON_HEIGHT = 34;
        const int BUTTON_WIDTH = 68;
        const int TASK_BAR_HEIGHT = 43;
        const string COMMAND_PARAMETER = "C:\\AceGrep\\AceGrep.pdf";
        const string COPYRIGHT = "Copyright 2018 Sogaya";
        const string EMPTY = "";
        const string ERROR_TEXT = "error.txt";
        const string SIDE_ACE_C_SHARP = "SideAce C#";
        const string VERSION_GAP = "Version ";

        string version = "1.01";

        public Version()
        {
            InitializeComponent();
        }

        public void setVersion(string v)
        {
            version = v;
            label3.Text = VERSION_GAP + version;
        }

        private void Version_Load(object sender, EventArgs e)
        {
            int adjuster = 0 - TASK_BAR_HEIGHT;
            int SCREEN_HEIGHT = Screen.PrimaryScreen.Bounds.Height + adjuster;
            int SCREEN_WIDTH = Screen.PrimaryScreen.Bounds.Width;

            KeyPreview = true;
            button1.Height = BUTTON_HEIGHT;
            button1.Width = BUTTON_WIDTH;
            label1.Text = SIDE_ACE_C_SHARP;
            label2.Text = COPYRIGHT;

            Left = (SCREEN_WIDTH - Width) / 2;
            Top = (SCREEN_HEIGHT - Height) / 2;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                Process p = new Process();
                p.StartInfo.FileName = COMMAND_PARAMETER;
                p.StartInfo.Arguments = EMPTY;
                p.Start();
            }
            catch (Win32Exception e8)
            {
                // ERROR_TEXT
                StreamWriter e8_file = File.CreateText(ERROR_TEXT);
                e8_file.WriteLine(e8.ToString());
                e8_file.Close();
            }
            catch (InvalidOperationException e9)
            {
                // ERROR_TEXT
                StreamWriter e9_file = File.CreateText(ERROR_TEXT);
                e9_file.WriteLine(e9.ToString());
                e9_file.Close();
            }

        }

        private void Version_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Escape)
            {
                Close();
            }

        }
    }
}
