#!/usr/bin/awk -f
#
#
# awk -f LineNo.awk > LineNo.txt
# awk -f LineNo.awk 640 > LineNo.txt
#

BEGIN {
    if(ARGC == 2) {
        s = ARGV[1]
    }
    
    s = s + 0
    if(s == 0) {
        s = 384
    }
    
    for(i = 1; i <= 1024; i++) {
        if( i == s - 1 ) {
            difference = 1
            printf("Line-%d: %d line to Line-%s\n", i, difference, s)
        } else if(i == s) {
            printf("Line-%d\n", i)
        } else if( i == s + 1 ) {
            difference = 1
            printf("Line-%d: %d line from Line-%s\n", i, difference, s)
        } else if(i < s) {
            difference = s - i
            printf("Line-%d: %d lines to Line-%s\n", i, difference, s)
        } else {
            difference = i - s
            printf("Line-%d: %d lines from Line-%s\n", i, difference, s)
        }
        
    }
    
    exit
}
