#define FILE_NAME_SIZE 253
#define ARRAY_SIZE 4096
#define LIMIT 3
#define TRUE 1
#define VERSION 1.01
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
bell Version 1.01
Copyright 2018 Sogaya
Sending alert characters to the standard output

Borland C++ 5.5.1 for Win32

bell -V
echo | bell
echo | bell > bell.txt

*/

typedef int BOOL;
void guide();

int main(int argc, char *argv[]) {
    BOOL standard_input = 0; // FALSE
    char *p;
    char *stop;
    char c[ARRAY_SIZE];
    char file_name[ FILE_NAME_SIZE + 1 ];
    FILE *file;
    int count = 0;
    int limit = LIMIT;
    
    switch(argc) {
    case 1:
        file = stdin;
        standard_input = TRUE;
        break;
    case 2:
        if(! strcmp(argv[1], "-V") ) {
            guide();
            return 1;
        }
        
        p = argv[1];
        if(*p == '-') {
            file = stdin;
            standard_input = TRUE;
            limit = (int)strtol(++p, &stop, 10);
        } else {
            strcpy(file_name, argv[1]);
        }
        
        break;
    default:
        break;
    }
    
    if(standard_input) {
        ;
    } else {
        file = fopen(file_name, "rt");
        if(file == NULL) {
            perror("bell.exe");
            guide();
            return 1;
        }
        
    }
    
    while(count < limit) {
        p = fgets(c, ARRAY_SIZE, file);
        if(p == NULL) {
            break;
        }
        
        putchar(0x07); // bell
        count += 1;
    }
    
    if(standard_input) {
        ;
    } else {
        fclose(file);
    }
    
    return 0;
}

void guide() {
    printf("bell Version %f\n\n", VERSION);
    puts("bell -12 < lines.txt");
    puts("bell -12");
    puts("bell -V");
    puts("bell < lines.txt");
    puts("bell  lines.txt");
    puts("echo | bell");
    puts("echo | bell > bell.txt");
}
