#define ANCIENT 1900
#define GUIDE "funbyo Version 1.01 \n\nfunbyo \nfunbyo -g \nfunbyo -h \nfunbyo -iso \nfunbyo -_ \nfunbyo -V \nfunbyo -g -y-\nfunbyo -g -ym-\nfunbyo -g -ymd-\nfunbyo -g -s-\nfunbyo -g -ms-\nfunbyo -g -hms-\n"
#define JANUARY 1
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

/*
funbyo Version 1.01
Reporting date and time
Copyright 2018 Sogaya

Borland C++ 5.5.1 for Win32

*/

int main(int argc, char *argv[]) {
    int month, year;
    long m;
    struct tm *p;
    
    time(&m);
    p = localtime(&m);
    month = JANUARY + p->tm_mon;
    year = ANCIENT + p->tm_year;

    switch(argc) {
    case 2:
        if(! strcmp(argv[1], "-V") ) {
            puts(GUIDE);
            return 1;
        } else if(! strcmp(argv[1], "-g") ) {
            printf("%04d-%02d-%02d %02d:%02d:%02d", year, month, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);
        } else if(! strcmp(argv[1], "-h") ) {
            printf("%02d:%02d:%02d", p->tm_hour, p->tm_min, p->tm_sec);
        } else if(! strcmp(argv[1], "-iso") ) {
            printf("%04d-%02d-%02dT%02d:%02d:%02d", year, month, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);
        } else if(! strcmp(argv[1], "-_") ) {
            printf("%04d-%02d-%02d_%02d-%02d-%02d", year, month, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);
        }
        
        return 0;
    case 3:
        if(! strcmp(argv[1], "-V") ) {
            puts(GUIDE);
            return 1;
        } else if(! strcmp(argv[1], "-g") ) {
            break;
        } else {
            puts(GUIDE);
            return 1;
        }
        
    default:
        printf("%02d:%02d", p->tm_min, p->tm_sec);
        return 0;
    }
    
    if(! strcmp(argv[2], "-y-") ) {
            printf("%02d-%02d %02d:%02d:%02d", month, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);
    } else if(! strcmp(argv[2], "-ym-") ) {
        printf("%02d %02d:%02d:%02d", p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);
    } else if(! strcmp(argv[2], "-ymd-") ) {
        printf("%02d:%02d:%02d", p->tm_hour, p->tm_min, p->tm_sec);
    } else if(! strcmp(argv[2], "-s-") ) {
        printf("%04d-%02d-%02d %02d:%02d", year, month, p->tm_mday, p->tm_hour, p->tm_min);
    } else if(! strcmp(argv[2], "-ms-") ) {
        printf("%04d-%02d-%02d %02d", year, month, p->tm_mday, p->tm_hour);
    } else if(! strcmp(argv[2], "-hms-") ) {
        printf("%04d-%02d-%02d", year, month, p->tm_mday);
    }
    
    return 0;
}
